<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css,table.css">
<script language="JavaScript">

function createMissingItems()
{
	init('Install');
}

function init(cmd)
{
	var request = Ajax.getXmlHttpRequest();
	var url = 'Install.servlet?ID=<%=ID%>&cmd='+cmd;
	request.open("GET", url, false); 
	request.send(null);
	
	//setInnerHTML('debug', request.responseText);
	
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var numMissing = 0;
	var numErrors = 0;
	var checks = response.checks;
	var html = '<table border="0" cellpadding="0" cellspacing="0" class="report">';
	html += '<tr><th id="itemTypeCol">Item type</th><th id="nameCol">Name</th><th id="iconCol"></th><th id="statusCol">Status</th></tr>';
	var lastItemType = null;
	for (var i = 0; i < checks.length; i++)
	{
		var check = checks[i];
		var icon = check.status == 'ok' ? 'ok.gif' : 'error.gif';
		if (check.status == 'missing') numMissing++;
		if (check.status == 'error') numErrors++;
		if (lastItemType != check.itemType)
		{
			html += '<tr class="newitemtype"><td>'+check.itemType+'</td>';
		}
		else
		{
			html += '<tr><td>&nbsp;</td>';
		}
		lastItemType = check.itemType;
		html += '<td><div class="link" onclick="itemOnClick(event, \''+check.itemType+'\','+check.id+')"';
		html += ' title="View this item (use CTRL, ALT or SHIFT to edit)">'+check.name+'</div></td>';
		html += '<td><img src="../../images/'+icon+'"></td>';
		html += '<td>'+check.message+'</td>';
		html += '</tr>';
	}
	html += '</table>';

	setInnerHTML('validationResult', html);
	
	if (numErrors > 0)
	{
		setFatalError(numErrors+' errors was detected. You need to fix those manually.');	
	}
	Main.showHide('createMissingItems', numMissing > 0);	
	
}

function setInnerHTML(id, html)
{
	var tag = document.getElementById(id);
	if (!tag) alert('No tag with id='+id);
	tag.innerHTML = html;
}
function setFatalError(message)
{
	setInnerHTML('errorMessage', message);
	Main.show('errorMessage');
}

function itemOnClick(event, itemType, itemId)
{
	Main.itemOnClick(event, '<%=ID%>', itemType, itemId, true);
}
</script>
<style>
.report
{
	border: 1px solid #999999;
	width: 800px;
	table-layout: fixed;
}

.report #itemTypeCol
{
	width: 150px;
}

.report #nameCol
{
	width: 200px;
}
.report #iconCol
{
	width: 20px;
}
.report #statusCol
{}


.report th
{
	font-weight: bold;
	text-align: left;
	background: #E0E0E0;
	padding: 2px 4px 2px 4px;
}

.report td
{
	padding: 2px;
}

.report .newitemtype td
{
	border-top: 1px  solid #999999;
}

</style>
</base:head>
<base:body onload="init('Validate')">

	<p:path style="margin-top: 20px; margin-bottom: 10px;">
		<p:pathelement title="Reggie" href="<%="index.jsp?ID="+ID%>" />
		<p:pathelement title="Verify/install required items" />
	</p:path>

	<div id="validationResult" style="margin-left: 20px;">Checking; please wait...</div>

	<div class="error" id="errorMessage" style="display: none; width: 800px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="createMissingItems" style="display:none; margin-left: 20px; margin-top: 10px;">
		<table><tr><td>
		<base:button title="Create missing items" image="add.png" onclick="createMissingItems()"/>
		</td></tr></table>
	</div>

	<pre>
	<div id="debug"></div>
	</pre>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>